ICU 60.2 60.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- File List
- Globals

Namespaces | Typedefs | Enumerations | Functions
ubiditransform.h File Reference

Bidi Transformations. More...

`#include "unicode/utypes.h"`
`#include "unicode/ubidi.h"`
`#include "unicode/uchar.h"`
`#include "unicode/localpointer.h"`

Go to the source code of this file.

## Namespaces
| icu
| File coll.h.

## Typedefs
typedef struct UBiDiTransform | UBiDiTransform
| Forward declaration of the `UBiDiTransform` structure that stores information used by the layout transformation engine. More...

## Enumerations
enum | UBiDiOrder { UBIDI_LOGICAL = 0, UBIDI_VISUAL }
enum | UBiDiMirroring { UBIDI_MIRRORING_OFF = 0, UBIDI_MIRRORING_ON }
| `UBiDiMirroring` indicates whether or not characters with the "mirrored" property in RTL runs should be replaced with their mirror-image counterparts. More...

## Functions
uint32_t | ubiditransform_transform (UBiDiTransform *pBiDiTransform, const UChar *src, int32_t srcLength, UChar *dest, int32_t destSize, UBiDiLevel inParaLevel, UBiDiOrder inOrder, UBiDiLevel outParaLevel, UBiDiOrder outOrder, UBiDiMirroring doMirroring, uint32_t shapingOptions, UErrorCode *pErrorCode)
| Performs transformation of text from the bidi layout defined by the input ordering scheme to the bidi layout defined by the output ordering scheme, and applies character mirroring and Arabic shaping operations. More...
UBiDiTransform * | ubiditransform_open (UErrorCode *pErrorCode)
| Allocates a `UBiDiTransform` object. More...
void | ubiditransform_close (UBiDiTransform *pBidiTransform)
| Deallocates the given `UBiDiTransform` object. More...

## Detailed Description

Bidi Transformations.

`UBiDiOrder` indicates the order of text.

This bidi transformation engine supports all possible combinations (4 in total) of input and output text order:

- <logical input, visual output>: unless the output direction is RTL, this corresponds to a normal operation of the Bidi algorithm as described in the Unicode Technical Report and implemented by `UBiDi` when the reordering mode is set to `UBIDI_REORDER_DEFAULT`. Visual RTL mode is not supported by `UBiDi` and is accomplished through reversing a visual LTR string,
- <visual input, logical output>: unless the input direction is RTL, this corresponds to an "inverse bidi algorithm" in `UBiDi` with the reordering mode set to `UBIDI_REORDER_INVERSE_LIKE_DIRECT`. Visual RTL mode is not not supported by `UBiDi` and is accomplished through reversing a visual LTR string,
- <logical input, logical output>: if the input and output base directions mismatch, this corresponds to the `UBiDi` implementation with the reordering mode set to `UBIDI_REORDER_RUNS_ONLY`; and if the input and output base directions are identical, the transformation engine will only handle character mirroring and Arabic shaping operations without reordering,
- <visual input, visual output>: this reordering mode is not supported by the `UBiDi` engine; it implies character mirroring, Arabic shaping, and - if the input/output base directions mismatch - string reverse operations.

See also
  ubidi_setInverse
  ubidi_setReorderingMode
  UBIDI_REORDER_DEFAULT
  UBIDI_REORDER_INVERSE_LIKE_DIRECT
  UBIDI_REORDER_RUNS_ONLY

Stable:
  ICU 58

Definition in file ubiditransform.h.

## Typedef Documentation

typedef struct UBiDiTransform UBiDiTransform

Forward declaration of the `UBiDiTransform` structure that stores information used by the layout transformation engine.

Stable:
  ICU 58

Definition at line 107 of file ubiditransform.h.

## Enumeration Type Documentation

enum UBiDiMirroring

`UBiDiMirroring` indicates whether or not characters with the "mirrored" property in RTL runs should be replaced with their mirror-image counterparts.

See also
  UBIDI_DO_MIRRORING
  ubidi_setReorderingOptions
  ubidi_writeReordered
  ubidi_writeReverse

Stable:
  ICU 58

Enumerator
UBIDI_MIRRORING_OFF | 0: Constant indicating that character mirroring should not be performed. This is the default. Stable: ICU 58
UBIDI_MIRRORING_ON | 1: Constant indicating that character mirroring should be performed. This corresponds to calling `ubidi_writeReordered` or `ubidi_writeReverse` with the `UBIDI_DO_MIRRORING` option bit set. Stable: ICU 58

Definition at line 86 of file ubiditransform.h.

enum UBiDiOrder

Enumerator
UBIDI_LOGICAL | 0: Constant indicating a logical order. This is the default for input text. Stable: ICU 58
UBIDI_VISUAL | 1: Constant indicating a visual order. This is a default for output text. Stable: ICU 58

Definition at line 63 of file ubiditransform.h.

## Function Documentation

void ubiditransform_close | ( | UBiDiTransform * | pBidiTransform | ) |

Deallocates the given `UBiDiTransform` object.

Stable:
  ICU 58

UBiDiTransform* ubiditransform_open | ( | UErrorCode * | pErrorCode | ) |

Allocates a `UBiDiTransform` object.

This object can be reused, e.g. with different ordering schemes, mirroring or shaping options.

Note:The object can only be reused in the same thread. All other threads should allocate a new `UBiDiTransform` object before using it.

Example of usage:

        1   UErrorCode errorCode = U_ZERO_ERROR;    2   // Open a new UBiDiTransform.    3   UBiDiTransform* transform = ubiditransform_open(&errorCode);    4   // Run a transformation.    5   ubiditransform_transform(transform,    6            text1, -1, text2, -1,    7            UBIDI_RTL, UBIDI_LOGICAL,    8            UBIDI_LTR, UBIDI_VISUAL,    9            UBIDI_MIRRORING_ON,   10            U_SHAPE_DIGITS_EN2AN,   11            &errorCode);   12   // Do something with the output text and invoke another transformation using   13   //   that text as input.   14   ubiditransform_transform(transform,   15            text2, -1, text3, -1,   16            UBIDI_LTR, UBIDI_VISUAL,   17            UBIDI_RTL, UBIDI_VISUAL,   18            UBIDI_MIRRORING_ON,   19            0, &errorCode);   20 *

The `UBiDiTransform` object must be deallocated by calling `ubiditransform_close()`.

Returns
  An empty `UBiDiTransform` object.

Stable:
  ICU 58

uint32_t ubiditransform_transform | ( | UBiDiTransform * | pBiDiTransform,
|  | const UChar * | src,
|  | int32_t | srcLength,
|  | UChar * | dest,
|  | int32_t | destSize,
|  | UBiDiLevel | inParaLevel,
|  | UBiDiOrder | inOrder,
|  | UBiDiLevel | outParaLevel,
|  | UBiDiOrder | outOrder,
|  | UBiDiMirroring | doMirroring,
|  | uint32_t | shapingOptions,
|  | UErrorCode * | pErrorCode
| ) |  |

Performs transformation of text from the bidi layout defined by the input ordering scheme to the bidi layout defined by the output ordering scheme, and applies character mirroring and Arabic shaping operations.

In terms of `UBiDi`, such a transformation implies:

- calling `ubidi_setReorderingMode` as needed (when the reordering mode is other than normal),
- calling `ubidi_setInverse` as needed (when text should be transformed from a visual to a logical form),
- resolving embedding levels of each character in the input text by calling `ubidi_setPara`,
- reordering the characters based on the computed embedding levels, also performing character mirroring as needed, and streaming the result to the output, by calling `ubidi_writeReordered`,
- performing Arabic digit and letter shaping on the output text by calling `u_shapeArabic`.

An "ordering scheme" encompasses the base direction and the order of text, and these characteristics must be defined by the caller for both input and output explicitly .

There are 36 possible combinations of <input, output> ordering schemes, which are partially supported by `UBiDi` already. Examples of the currently supported combinations:

- <Logical LTR, Visual LTR>: this is equivalent to calling `ubidi_setPara` with `paraLevel == UBIDI_LTR`,
- <Logical RTL, Visual LTR>: this is equivalent to calling `ubidi_setPara` with `paraLevel == UBIDI_RTL`,
- <Logical Default ("Auto") LTR, Visual LTR>: this is equivalent to calling `ubidi_setPara` with `paraLevel == UBIDI_DEFAULT_LTR`,
- <Logical Default ("Auto") RTL, Visual LTR>: this is equivalent to calling `ubidi_setPara` with `paraLevel == UBIDI_DEFAULT_RTL`,
- <Visual LTR, Logical LTR>: this is equivalent to calling `ubidi_setInverse(UBiDi*, TRUE)` and then `ubidi_setPara` with `paraLevel == UBIDI_LTR`,
- <Visual LTR, Logical RTL>: this is equivalent to calling `ubidi_setInverse(UBiDi*, TRUE)` and then `ubidi_setPara` with `paraLevel == UBIDI_RTL`.

All combinations that involve the Visual RTL scheme are unsupported by `UBiDi`, for instance:

- <Logical LTR, Visual RTL>,
- <Visual RTL, Logical RTL>.

Example of usage of the transformation engine:

        1   UChar text1[] = {'a', 'b', 'c', 0x0625, '1', 0};    2   UChar text2[] = {'a', 'b', 'c', 0x0625, '1', 0};    3   UErrorCode errorCode = U_ZERO_ERROR;    4   // Run a transformation.    5   ubiditransform_transform(pBidiTransform,    6            text1, -1, text2, -1,    7            UBIDI_LTR, UBIDI_VISUAL,    8            UBIDI_RTL, UBIDI_LOGICAL,    9            UBIDI_MIRRORING_OFF,   10            U_SHAPE_DIGITS_AN2EN | U_SHAPE_DIGIT_TYPE_AN_EXTENDED,   11            &errorCode);   12   // Do something with text2.   13    text2[4] = '2';   14   // Run a reverse transformation.   15   ubiditransform_transform(pBidiTransform,   16            text2, -1, text1, -1,   17            UBIDI_RTL, UBIDI_LOGICAL,   18            UBIDI_LTR, UBIDI_VISUAL,   19            UBIDI_MIRRORING_OFF,   20            U_SHAPE_DIGITS_EN2AN | U_SHAPE_DIGIT_TYPE_AN_EXTENDED,   21            &errorCode);   22 *

Parameters

  pBiDiTransform | A pointer to a `UBiDiTransform` object allocated with `ubiditransform_open()` or `NULL`.

This object serves for one-time setup to amortize initialization overheads. Use of this object is not thread-safe. All other threads should allocate a new `UBiDiTransform` object by calling `ubiditransform_open()` before using it. Alternatively, a caller can set this parameter to `NULL`, in which case the object will be allocated by the engine on the fly.

Parameters

  src | A pointer to the text that the Bidi layout transformations will be performed on.

Note: the text must be (at least) `srcLength` long.

Parameters

  srcLength | The length of the text, in number of UChars. If `length == -1` then the text must be zero-terminated.
  dest | A pointer to where the processed text is to be copied.
  destSize | The size of the `dest` buffer, in number of UChars. If the `U_SHAPE_LETTERS_UNSHAPE` option is set, then the destination length could be as large as `srcLength * 2`. Otherwise, the destination length will not exceed `srcLength`. If the caller reserves the last position for zero-termination, it should be excluded from `destSize`.

`destSize == -1` is allowed and makes sense when `dest` was holds some meaningful value, e.g. that of `src`. In this case `dest` must be zero-terminated.

Parameters

  inParaLevel | A base embedding level of the input as defined in `ubidi_setPara` documentation for the `paraLevel` parameter.
  inOrder | An order of the input, which can be one of the `UBiDiOrder` values.
  outParaLevel | A base embedding level of the output as defined in `ubidi_setPara` documentation for the `paraLevel` parameter.
  outOrder | An order of the output, which can be one of the `UBiDiOrder` values.
  doMirroring | Indicates whether or not to perform character mirroring, and can accept one of the `UBiDiMirroring` values.
  shapingOptions | Arabic digit and letter shaping options defined in the ushape.h documentation.

Note: Direction indicator options are computed by the transformation engine based on the effective ordering schemes, so user-defined direction indicators will be ignored.

Parameters

  pErrorCode | A pointer to an error code value.

Returns
  The destination length, i.e. the number of UChars written to `dest`. If the transformation fails, the return value will be 0 (and the error code will be written to `pErrorCode`).

See also
  UBiDiLevel
  UBiDiOrder
  UBiDiMirroring
  ubidi_setPara
  u_shapeArabic

Stable:
  ICU 58